/*******************************************************************************
 * FoxGRI_CP generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGRI_CP extends FoxGRI_TDM
    native
    config(Game)
    hidecategories(Navigation,Movement,Collision);

// Export UFoxGRI_CP::execCheckScore(FFrame&, void* const)
native simulated function CheckScore(Controller PC);

simulated function GameAction(name CPLetter, name ActionName)
{
    local array<string> args;
    local PlayerController PC;

    PC = GetALocalPlayerController();
    // End:0x112
    if(PC != none)
    {
        args.AddItem("Dia_Dom_GameAction");
        args.AddItem(FoxTeamInfo(PC.PlayerReplicationInfo.Team).GetDialogName());
        args.AddItem(GameTypeCode);
        args.AddItem(string(ActionName));
        args.AddItem(string(CPLetter));
        PC.PostAkDialog(args, true);
    }
    //return;    
}

simulated function StoreGameSpecificSettings(FoxSavedMigrationInfo SavedInfo)
{
    local FoxGameObject_ControlPoint CP;
    local int CPIndex;

    // End:0xC5
    foreach WorldInfo.DynamicActors(class'FoxGameObject_ControlPoint', CP)
    {
        CPIndex = CP.ControlPointType - 1;
        // End:0xC4
        if((CPIndex >= 0) && CPIndex < 3)
        {
            SavedInfo.CPOwners[CPIndex] = CP.GetCPOwner();
        }        
    }    
    super(FoxGRI).StoreGameSpecificSettings(SavedInfo);
    //return;    
}

// Export UFoxGRI_CP::execGetPRIThreatLevel(FFrame&, void* const)
native simulated function int GetPRIThreatLevel(FoxPRI PRI);

function NotifyCapturePointChange(int OldTeamIndex, int NewTeamIndex)
{
    local FoxTeamInfo Team1, Team2;

    // End:0x13
    if(Teams.Length < 2)
    {
        return;
    }
    Team1 = FoxTeamInfo(Teams[0]);
    Team2 = FoxTeamInfo(Teams[1]);
    // End:0xC0
    if(OldTeamIndex != -1)
    {
        // End:0x91
        if(OldTeamIndex == 0)
        {
            -- Team1.NumCapturedPoints;
        }
        // End:0xC0
        if(OldTeamIndex == 1)
        {
            -- Team2.NumCapturedPoints;
        }
    }
    // End:0x131
    if(NewTeamIndex != -1)
    {
        // End:0x102
        if(NewTeamIndex == 0)
        {
            ++ Team1.NumCapturedPoints;
        }
        // End:0x131
        if(NewTeamIndex == 1)
        {
            ++ Team2.NumCapturedPoints;
        }
    }
    FoxGame(WorldInfo.Game).BroadcastPawnUseDialog(2,, byte(NewTeamIndex));
    //return;    
}

simulated function int GetScoreForEvent(FoxTypes.EScoreEvents EventType)
{
    switch(EventType)
    {
        // End:0x43
        case 6:
            return class<FoxScoringInfoCP>(ScoringInfoClass).default.ExpPointAttack;
            // End:0x136
            break;
        // End:0x73
        case 7:
            return class<FoxScoringInfoCP>(ScoringInfoClass).default.ExpPointDefend;
            // End:0x136
            break;
        // End:0xA3
        case 8:
            return class<FoxScoringInfoCP>(ScoringInfoClass).default.ExpPointCapture;
            // End:0x136
            break;
        // End:0xD3
        case 10:
            return class<FoxScoringInfoCP>(ScoringInfoClass).default.ExpPointHack;
            // End:0x136
            break;
        // End:0x103
        case 12:
            return class<FoxScoringInfoCP>(ScoringInfoClass).default.ExpPointCaptureAssist;
            // End:0x136
            break;
        // End:0x133
        case 11:
            return class<FoxScoringInfoCP>(ScoringInfoClass).default.ExpHoldScoreInterval;
            // End:0x136
            break;
        // End:0xFFFF
        default:
            return super(FoxGRI).GetScoreForEvent(EventType);
    }
    //return ReturnValue;    
}

simulated function float GetIntervalForEvent(FoxTypes.EScoreEvents EventType)
{
    switch(EventType)
    {
        // End:0x45
        case 11:
            return float(class<FoxScoringInfoCP>(ScoringInfoClass).default.HoldInterval);
            // End:0x48
            break;
        // End:0xFFFF
        default:
            return super(FoxGRI).GetIntervalForEvent(EventType);
    }
    //return ReturnValue;    
}

defaultproperties
{
    ScoringInfoClass=class'FoxScoringInfoCP'
    NumNodes=3.0
    GameTypeAudioBanks(0)=AkBank'A_ControlPoint.Bank.ControlPoint'
    DialogActionCategory="CapturePoint"
    GameTypeCode="Dom"
    GameClass=class'FoxGameMP_CP'
}